# Changelog

<a name="5.0.0"></a>
## [5.0.0](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/4.2.1...5.0.0) (2024-08-08)

### 🛡️ Security

- **🚨 BREAKING CHANGE 🚨 -** **cli:** acquire tokens only from environment variables ([3f211bd](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/3f211bd41e92f022c3648b670643c7f13ff5cd2d))

### ✨ Features

- **🚨 BREAKING CHANGE 🚨 -** **cli:** refactor CLI into simpler GitLab URL bound parameters ([1aa72a4](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/1aa72a4d5157ccb0be248fa7720cedf5d371e99e))
- **cli:** implement '--confirm' to bypass interactive user confirmations ([1bf9b99](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/1bf9b99be28d99b232b098cc3040e7f5b8f8d4f0))
- **cli:** add tool identifier header with name and version ([4362101](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/436210131eba06452f6b79e4ed46815c9f08fbd7))
- **cli:** implement '.python-gitlab.cfg' GitLab configurations files ([271c7c8](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/271c7c8f9a645e5cacfc1fc9990dab2bfbad0663))
- **cli, argparse:** implement environment variables helpers ([7f4caec](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/7f4caecf2c867944fa3aaa39d6f4c0eac4b0aebc))
- **cli, gitlab:** implement '--prune-unreachable-objects' feature ([d07b179](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/d07b1799110a1d64a48f07042275f84e0a3e8841))
- **cli, gitlab:** implement '--erase-jobs-artifacts' to erase jobs artifacts ([75109f3](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/75109f3820f42d8807f6430d2a3871494855bcda))
- **cli, gitlab:** implement '--erase-jobs-contents' to erase jobs contents ([24b82bc](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/24b82bcdebbecb0e1ecf1f9cb8999950b6b22793))
- **cli, gitlab:** implement CI job token and public authentications ([291777c](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/291777c1d752cb3ca15761abb1dccc63114a2f4c))
- **cli, gitlab:** implement '--{get,set}-project-labels' with JSON ([f1bf888](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/f1bf888e8e1ac54f18d1ad8c864eb176a61b1657))
- **cli, gitlab:** implement '--{get,set}-group-labels' with JSON ([24305b5](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/24305b5a00b1dbb7d395d3add72132424bc36015))
- **cli, gtlab:** implement '--set-merge-method' for merge requests ([969e9ec](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/969e9ec0445dffcca7e9b4ce77f710cf231befb4))
- **cli, gtlab:** implement '--set-merge-squash' for merge requests ([6d50073](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/6d500735e97d32204ed4ef64d9c8e6915aab70ea))
- **cli, gtlab:** implement '--set-merge-pipelines' for merge requests ([13f150d](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/13f150d5335557d89c1f6d31ab6439d44569603b))
- **cli, gtlab:** implement '--set-merge-skipped' for merge requests ([d65d112](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/d65d1120fa035db1bb8194fa441cb53a14d20e3b))
- **cli, gtlab:** implement '--set-merge-resolved' for merge requests ([9d3c51c](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/9d3c51ca49a561f070c8009ec0dbd4d90a3725d8))
- **entrypoint:** wrap '--available-features' outputs with ' ([09cd008](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/09cd008cbd43d2e5ddb2a785cd94a60b4bbcc4f3))

### 🐛 Bug Fixes

- **environments:** add missing ':' to the README help description ([48b947b](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/48b947bb3cbafd59f584bc90a24d3533e3a510a4))
- **gitlab:** wait 3 seconds after group and project deletions ([9a273bb](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/9a273bb38babc82d72f768dbad320c550fc3670d))

### 📚 Documentation

- **cliff:** document 'security(...)' first in changelog ([eced346](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/eced346b5227cacb57da930865b65d8cef55e83e))
- **readme:** document '~/.python-gitlab.cfg' configuration file ([c62ae1e](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/c62ae1e6b4ba45f894a212d2ad4ed3d68476cfae))

### ⚙️ Cleanups

- **cli/main:** minor codestyle improvement of 'import argparse' ([1b84f36](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/1b84f368684ef0a8e34f20267fa6e90400df1a06))
- **entrypoint:** refactor 'confirm' against 'gitlab-projects-migrate' ([35f5139](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/35f513955a44377c73c4d8cee2f9a04330b7d63f))
- **entrypoint, gitlab:** bind 'ProjectFeatures' names directly ([39d0d07](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/39d0d07748e00c0074f011b14304e26ccb7f0fe7))
- **gitlab:** acquire project and group despite '--dry-run' use ([462041d](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/462041db1b2817daa0a93712a040a5c2abdb1d50))
- **types:** cleanup inconsistent '()' over base classes ([ef60d62](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/ef60d6200a3a45ea6dd88253f8892721314ff4ee))

### 🚀 CI

- **gitlab-ci:** migrate from 'git-chglog' to 'git-cliff' ([99fad86](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/99fad86afc05c7360d186e5bd28b355161136ad3))


<a name="4.2.1"></a>
## [4.2.1](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/4.2.0...4.2.1) (2024-06-10)

### 🐛 Bug Fixes

- **gitlab:** restore support for old GitLab 13.12 instances ([de82a80](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/de82a807754d512a756c35b4b2ecbbe0c6e54424))

### 📚 Documentation

- **chglog:** add 'ci' as 'CI' configuration for 'CHANGELOG.md' ([440c1ed](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/440c1edde7c8b62919943c4f6ffa4c40bc54a14f))

### 🚀 CI

- **gitlab-ci:** support docker pull and push without remote ([c0becd7](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/c0becd77921b7fdabe810e5f7983dd9f49c320ae))
- **gitlab-ci:** use 'CI_DEFAULT_BRANCH' to access 'develop' branch ([c0fc6dd](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/c0fc6ddd3ade421fadb5d8df8b8f786137d2fdb0))
- **gitlab-ci:** change commit messages to tag name ([264dc2e](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/264dc2e999bb16cae4c5a517df8863cc282384d2))
- **setup:** update Python package keywords hints ([3f5d7d1](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/3f5d7d187f8e65307a91f06fe0ac40b0aaf6d14a))


<a name="4.2.0"></a>
## [4.2.0](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/4.1.0...4.2.0) (2024-05-26)

### ✨ Features

- **entrypoint:** improve outputs logs upon delections ([fd25605](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/fd256050a79365d05a0bd3a9beaf71113cb85057))
- **main:** show newer updates message upon incompatible arguments ([2ca5244](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/2ca5244b5bfed48408dc634cc58a36551510d5f7))
- **main, entrypoint:** implement '--dump' to dump JSON objects ([dc98c05](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/dc98c05c0e2785d5fffd03e36dfd5c8bbebd9330))

### 📚 Documentation

- **readme:** add 'gitlab-projects-settings' examples documentation ([4614846](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/4614846934f900fc8fa3644333732ed045f03d3b))


<a name="4.1.0"></a>
## [4.1.0](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/4.0.0...4.1.0) (2024-05-17)

### ✨ Features

- **entrypoint:** implement prompt confirmation upon deletions ([539ccf8](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/539ccf8dc9329bc096ac3e6f9f6e2f1bb8aaad58))
- **gitlab:** isolate 'ProtectionLevels' enumeration ([18abccf](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/18abccfc4124d1c7295ce4c8f5f9f83f5087bd4a))
- **main, gitlab:** handle '--protect-tags' default to 'no-one' ([6607c87](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/6607c87536dda09ff994cbcb523e7eb6788088e7))
- **requirements:** prepare 'questionary' library integration ([5007320](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/50073206afe64c82704cdf9177ea24a2adecd5a9))


<a name="4.0.0"></a>
## [4.0.0](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/3.0.0...4.0.0) (2024-05-15)

### ✨ Features

- **entrypoint, gitlab:** implement '--{disable,enable}-features' ([19791ac](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/19791ac6578aee830057f8840447db2e00b35b9b))
- **gitlab:** automatically wait for group and project deletions ([7f02512](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/7f0251254a1fff00fd33b61a24b02189b037c0a7))
- **gitlab:** isolate GitLab project features enumeration ([fae4640](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/fae4640f44f86e031058736b60be3075abe6e3a0))
- **gitlab:** prepare future access levels in 'project_reset_features' ([a42e515](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/a42e515deed4f8eeeec6d758197bd007a0b9ec34))
- **gitlab:** parse input features list and accept similar texts ([3df67d7](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/3df67d75b9fb1a2b8822c645480997d8fb3264f5))
- **main:** document optional '--' positional arguments separator ([878c719](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/878c719fcfedc43aa98ab90fbe4cab2eb97c22de))
- **main, gitlab:** implement '--reset-features [KEEP_FEATURES]' ([592a08c](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/592a08c9111b7ffca8e0f47bd650723769ba754e))
- **main, gitlab:** implement '--available-features' for user help ([5c90151](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/5c90151d6ec9e7b858e468c7153fb2985713151b))
- **main, settings:** implement 'Settings' from 'gitlabci-local' ([29cac8b](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/29cac8b59e4605f16cf80528f39e3a955bd84f7d))
- **main, upgrades:** implement 'Upgrades' from 'gitlabci-local' ([80665f0](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/80665f08414fffff4f59b303fd9ae2850f8b401e))

### 🐛 Bug Fixes

- **entrypoint:** use full paths instead of 'id' integer fields ([d06b36e](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/d06b36e84b63d121d09846dea69506e2338e27ed))
- **entrypoint:** avoid missing 'namespace_id' in 'User' responses ([17889e9](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/17889e956fbbec41fc17217d88d0ecc3b0ad7a7a))
- **entrypoint:** refactor to return no error upon final actions ([4d379ba](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/4d379bade031c2912604550beaf6b80b79b2f7c9))
- **entrypoint, gitlab:** resolve Python typings new warnings ([51b4f44](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/51b4f449d1148298831a7b78ad66ecf3065ddb9a))
- **gitlab:** accept deletion denials in 'project_reset_members' ([3b261f2](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/3b261f269fa3225f5a01cd1acc2e501ea686b0df))
- **gitlab:** disable 'Repository' group feature after its members ([939c303](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/939c303113d53335e2de17d7f9c2ed10a3b9ffca))
- **gitlab:** disable all 'Repository' member features too ([42f3d18](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/42f3d180b18343de6d501d1f0f07619228ac1f5f))

### 🚜 Code Refactoring

- **gitlab:** isolate 'GitLabFeature.AccessLevels' constants ([9ba30b6](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/9ba30b62c93de8d846e271a3fa0eed084d7fde8c))
- **gitlab:** isolate GitLab types to 'types/gitlab.py' ([7a5f5eb](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/7a5f5eb450e66823506cc221398696fbb8572d0c))
- **gitlab:** optimize and centralize GitLab features handlings ([2c52366](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/2c52366fe1bee8f5a589bf6060083e6ea1c0b563))

### 🧪 Test

- **version:** add 'DEBUG_VERSION_FAKE' for debugging purposes ([fe3acdf](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/fe3acdf5df1db57d58792bb8a4ab2e27dbaa567b))

### ⚙️ Cleanups

- **entrypoint:** minor Python codestyle improvement ([66ddb28](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/66ddb2807e08ad96b2e0e8f5249d4d965e825a96))

### 🚀 CI

- **gitlab-ci:** handle optional parameters and multiline in 'readme' ([394f670](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/394f670e15e1e9cefcba59e6b5979454b67828c8))
- **gitlab-ci:** detect 'README.md' issues in 'readme' job ([094e565](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/094e565ea5b5dfc219f95bb3256d31c640b788ff))
- **gitlab-ci:** implement 'images' and use project specific images ([dd08c4a](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/dd08c4a1e69823176cea1c7ff3a10fd1c62b63f3))
- **gitlab-ci:** deprecate requirements install in 'lint' job ([b7b7aa7](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/b7b7aa7b96083aa8ce61a7d40d0178afa111d29e))
- **gitlab-ci:** support multiple 'METAVAR' words in 'readme' job ([2b6da44](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/2b6da44bf4298d281637b114828ebd33d3bba43a))


<a name="3.0.0"></a>
## [3.0.0](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/2.1.0...3.0.0) (2024-05-06)

### ✨ Features

- **cli, gitlab:** implement '--{archive,unarchive}-project' ([be6c241](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/be6c2415d618bf362bbda6828350120fc66bd29f))
- **cli, gitlab:** implement '--delete-{group,project}' ([3184259](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/318425966e008bf82244237dcaf6cda58cdd1679))
- **cli, gitlab:** implement '--run-housekeeping' ([2824960](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/282496067d8c7e591b21fba0c9e9c64a8800e0d7))
- **entrypoint:** always flush progress output logs ([d170a82](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/d170a82aeabe7d341cc40ca4b7ed37eacc9f4782))
- **entrypoint:** preserve main group description if exists ([f6f8a21](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/f6f8a21e726cd5823fa9cc610bd8134c60797805))
- **entrypoint, gitlab:** adapt name for '--update-description' ([2a5b165](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/2a5b16595958ac7c2b7f22af6e6e4ba26bab0b8e))
- **entrypoint, gitlab:** add support for user namespace projects ([1629e28](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/1629e28d593082eeed30bdeef4b211faecf5c3ed))
- **gitlab:** detect 'Token Access' usage for 'CI/CD' features ([24fb65a](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/24fb65a11220f2f54a4e3e712e1d3c697f31bd7b))
- **gitlab:** detect multiple branches to keep 'Merge requests' ([2130b2a](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/2130b2a87b1fbda05374c0d43252c5fbee15cc04))
- **namespaces:** migrate 'Helper' class to 'Namespaces' class ([81dbd95](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/81dbd95e0be6cd58df4479b8446ed227dc823381))

### 🐛 Bug Fixes

- **entrypoint:** enforce against missing '.description' values ([85e6d91](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/85e6d9180ffd10086c6e8d068ca4862aaa7f9a74))
- **entrypoint:** detect if GitLab actions can continue ([3074446](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/307444694fcb9c5ef1f6b76d9982559699c1cc6d))
- **entrypoint:** resolve support for private user namespaces ([ec9092a](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/ec9092a8fa399a7224a5e577079a504eb6b08f19))
- **gitlab:** get all members in 'project_reset_members' ([7db707c](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/7db707c95c875e08719cc003c9fb516c5acff186))
- **gitlab:** get all branches and tags upon 'list()' calls ([5a46bf2](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/5a46bf2d2712df3bea8047aa1c99d58d8ed569c4))
- **gitlab:** delay groups deletion by 10s and projects by 5s ([e56e054](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/e56e0548cab97c3aa39806685350edb6729f3e04))
- **gitlab:** enforce 'group_delete' usage in '--dry-run' mode ([29bdd98](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/29bdd98429292aa0f0ef155a45387454a11a602a))

### ⚙️ Cleanups

- **gitlab:** minor comments changes in 'project_reset_features' ([3470932](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/3470932b0306a49f4d300536f2b778c551dc98ee))

### 🚀 CI

- **gitlab-ci:** move 'readme' job after 'build' and local 'install' ([cc44651](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/cc44651d87ffeb7c13b4dc4892faf3ffbaea49cd))


<a name="2.1.0"></a>
## [2.1.0](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/2.0.2...2.1.0) (2024-04-28)

### ✨ Features

- **entrypoint:** keep description if already contains group ([abe2d34](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/abe2d3419926fd4d265c39278d56d80957b22c06))
- **entrypoint:** sort groups and projects recursively ([d2fa32c](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/d2fa32c56cc8c0242c154e8b05e31927ab54a1c5))

### 🐛 Bug Fixes

- **entrypoint:** fix project '--update-description' logs output ([3861e78](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/3861e78dd491e6acc862214ba7fca8200c0d0d82))


<a name="2.0.2"></a>
## [2.0.2](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/2.0.1...2.0.2) (2024-04-28)

### ✨ Features

- **main:** limit '--help' width to terminal width or 120 chars ([53916fd](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/53916fda053a74f712147b3f3b7ff05fc31708bd))

### 📚 Documentation

- **readme:** document GitLab tokens' creation instructions ([5253faa](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/5253faaf37efb24eca38a3d30a3ca3665d0ef0f1))

### 🚀 CI

- **gitlab-ci:** disable 'typing' mypy caching with 'MYPY_CACHE_DIR' ([efeca44](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/efeca449553840bf1afaee2203a70164b8825483))


<a name="2.0.1"></a>
## [2.0.1](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/2.0.0...2.0.1) (2024-04-27)

### ✨ Features

- **entrypoint, gitlab:** isolate 'GitLabFeature.Helper.capitalize' ([7e25627](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/7e25627ebc82fb051fea7bb5e09c5e504dbf0e33))

### 🐛 Bug Fixes

- **entrypoint:** fix description updates faulty descriptions ([98a6e75](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/98a6e7559b5202c50f79b8e0505e7d7adae0cbb7))
- **entrypoint, gitlab:** implement description to name fallbacks ([11c931f](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/11c931f886583dcc2bed26e149f96101bf664010))


<a name="2.0.0"></a>
## [2.0.0](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/1.1.0...2.0.0) (2024-04-27)

### ✨ Features

- **cli:** isolate 'features/settings.py' to 'cli/entrypoint.py' ([97b1214](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/97b121457c21b06e07edc6be8e27c5ae26e61c35))
- **main:** change '--set-description' metavar to 'TEXT' ([9640f6f](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/9640f6fbe3df0c822fef2c6cf1d877b5e88f3b1f))
- **main:** align 'RawTextHelpFormatter' to 30 chars columns ([d9e6273](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/d9e6273755463173288f0c038ffcb8a7b66e6f0d))
- **settings:** change project/group descriptions color ([7dfaea1](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/7dfaea1ef3b38997bc1181c0fe61f535ce4e31e4))

### 🐛 Bug Fixes

- **gitlab:** enforce '--dry-run' usage and improve Python codestyle ([bc1203a](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/bc1203a63997101bba72814c206c99fad9304543))
- **settings:** apply 'subgroup' feature to subgroup groups ([977596e](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/977596eb4d2ebfd4ffb6ed95e55b4ca89ff12ed1))

### 🚜 Code Refactoring

- **entrypoint:** minor Python codestyle improvements ([3b559f4](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/3b559f4b814b45eeaef5201756c289f83d007ab0))
- **src:** isolate all sources under 'src/' ([48f5d40](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/48f5d40b0813e40f8028289f55ddca6a672bdae9))

### 📚 Documentation

- **readme:** regenerate '--help' details in 'README.md' ([784121b](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/784121b80313b62d526926d63b71073848af1653))

### ⚙️ Cleanups

- **gitlab:** minor Python codestyle improvements ([b32f815](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/b32f8158937709f269a455b5a89e4c2d0a3f06c4))
- **settings:** minor Python codestyle improvements ([f1c179d](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/f1c179dd3b16ff4466e021a1d1cb04730a9a805f))
- **src:** ignore 'import-error' over '__init__' and '__main__' ([2fad230](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/2fad2300cb63867978ae1d3ff6038bbc4bbe8ac5))

### 🚀 CI

- **gitlab-ci:** implement 'readme' local job to update README details ([3ba2118](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/3ba21189642ab01762d3e5a8cd6fb7b47b3f0e1a))
- **gitlab-ci, setup:** migrate to 'src' sources management ([388187f](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/388187f9102982375fdb5dbc176aba019cccbb12))


<a name="1.1.0"></a>
## [1.1.0](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/1.0.1...1.1.0) (2024-04-25)

### ✨ Features

- **main:** rename '--avoid-*' parameters to '--exclude-*' ([f70ae44](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/f70ae4446d8ceaafa6ff992adc1596a95e0a3f45))

### 🚜 Code Refactoring

- **settings:** minor functions codestyle improvement ([e22206e](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/e22206ef37f070db6e7d51ac096ab577647fdeb8))


<a name="1.0.1"></a>
## [1.0.1](https://gitlab.com/AdrianDC/gitlab-projects-settings/compare/1.0.0...1.0.1) (2024-04-24)

### 📚 Documentation

- **setup:** fix PyPI 'gitlab-projects-settings' documentation ([66f2f97](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/66f2f976c97ae9a86f3151509f0035a867a0d1ff))


<a name="1.0.0"></a>
## [1.0.0](https://gitlab.com/AdrianDC/gitlab-projects-settings/commits/1.0.0) (2024-04-24)

### ✨ Features

- **gitlab-projects-settings:** initial sources implementation ([13a723f](https://gitlab.com/AdrianDC/gitlab-projects-settings/commit/13a723fd4f04cc871567944d7c978bc23b55eed6))


